import React, { Component } from 'react';

import Token from './Token';
import illuminate from 'illuminate-js';

const { tokenize, getLanguage } = illuminate;

export default class Illuminate extends Component {
    shouldComponentUpdate(nextProps) {
        return this.props.children !== nextProps.children || this.props.lang !== nextProps.lang;
    }

    render() {
        const { lang, children } = this.props;
        let token = children;

        const grammar = getLanguage(lang);

        if (grammar) {
            token = tokenize(children, grammar);
        }

        return React.createElement(
            'pre',
            { className: `language-${lang}` },
            React.createElement(
                'code',
                null,
                React.createElement(Token, { token: token })
            )
        );
    }
}