import React, { Component } from 'react';

export default class Token extends Component {
    render() {
        const { token } = this.props;

        if (typeof token === 'string') {
            return React.createElement(
                'span',
                null,
                token
            );
        }

        if (Array.isArray(token)) {
            return React.createElement(
                'span',
                null,
                token.map((t, i) => React.createElement(Token, { token: t, key: i }))
            );
        }

        const classes = ['token', token.type];

        if (token.alias) {
            const aliases = Array.isArray(token.alias) ? token.alias : [token.alias];

            classes.push(...aliases);
        }

        return React.createElement(
            'span',
            { className: classes.join(' ') },
            React.createElement(Token, { token: token.content })
        );
    }
}